unit SAXunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  TAttribute=Record
    name:String;
    value:String;
  end;
  TAttributeArray=Array[1..100] of TAttribute;
  TAttributeList=Record
    count:Integer;
    item:TAttributeArray;
  end;
  SAX = class
    parsedStr,log:String;
    f_xml:TextFile;

    procedure addString(fs:String);
    procedure setString(fs:String);
    procedure addLog(fs:String);
    procedure setLog(fs:String);

    function readForwardACharacter:String;
    function readToLess:String;
    function readToGreater:String;
    function readAWord(var endoftag:Boolean;var endofnode:Boolean):String;
    function readCDATASection:String;
    procedure readAttributesTo(var att_list:TAttributeList;var endofnode:Boolean);

    function getAttributeValue(attr_list:TAttributeList;aname:String):String;

    procedure startDocument;
    procedure endDocument;
    procedure startElement(ename:String;attr_list:TAttributeList);
    procedure endElement(ename:String);
    procedure findCharacters(value:String);

  public
    procedure parseXML(fname:String);
    function getString:String;
    function getLog:String;
  end;

implementation

{$I SAX_handler.inc}


function SAX.readForwardACharacter:String;
  var
    ch:Char;
begin
  //TODO: implementation: readForwardACharacter
  readForwardACharacter:='';
end;

function SAX.readToLess:String;
  var
    s1,s:String;
begin
  //TODO: implementation: readToLess
  readToLess:='';
end;

function SAX.readToGreater:String;
  var
    s1,s:String;
begin
  //TODO: implementation: readToGreater
  readToGreater:='';
end;

function SAX.readAWord(var endoftag:Boolean;var endofnode:Boolean):String;
  var
    s1,s:String;
begin
  //TODO: implementation: readAWord
  readAWord:='';
end;

function SAX.readCDATASection:String;
begin
  //TODO: implementation: readCDATASection
  // <![CDATA[...]]>   "<![" has already processed!
  readCDATASection:='';
end;

procedure SAX.readAttributesTo(var att_list:TAttributeList;var endofnode:Boolean);
  var
    s,e:String;
    endoftag:Boolean;
    p:integer;
begin
  //TODO: implementation: readAttributesTo
end;


(* Parse *)

procedure SAX.parseXML(fname:String);
  var
    s,ename,value:String;
    att_list:TAttributeList;
    endoftag,endofnode:Boolean;
begin
  //TODO: implementation: parseXML
  setString('');
  startDocument;
  addLog('Start of document');

  addLog('');
  addLog('Constant data --- begin');
  startElement('example',att_list);
  att_list.count:=1;
  att_list.item[1].name:='executive';
  att_list.item[1].value:='true';
  startElement('teacher',att_list);
  att_list.count:=0;
  startElement('etrid',att_list);
  findCharacters('ZSLABCD');
  endElement('etrid');
  startElement('name',att_list);
  findCharacters('Zsako, Laszlo');
  endElement('name');
  startElement('email',att_list);
  findCharacters('zsako@ludens.elte.hu');
  endElement('email');
  endElement('teacher');
  startElement('teacher',att_list);
  startElement('etrid',att_list);
  findCharacters('MELEAET');
  endElement('etrid');
  startElement('name',att_list);
  findCharacters('Menyhart, Laszlo');
  endElement('name');
  startElement('email',att_list);
  findCharacters('menyhart@inf.elte.hu');
  endElement('email');
  endElement('teacher');
  endElement('example');
  addLog('Constant data --- end');
  addLog('');


  endDocument;
  addLog('End of document');
end;


(* Search an attribute by key/name *)

function SAX.getAttributeValue(attr_list:TAttributeList;aname:String):String;
  var
    value:String;
    i:Integer;
begin
  //TODO: implementation: getAttributeValue
  //linear searching
  getAttributeValue:='';
end;



(* Getter / setter *)

function SAX.getString:String;
begin
  getString:=parsedStr;
end;

procedure SAX.setString(fs:String);
begin
  parsedStr:=fs;
end;

procedure SAX.addString(fs:String);
begin
  parsedStr:=parsedStr+fs+#13#10;
end;

function SAX.getLog:String;
begin
  getLog:=log;
end;

procedure SAX.setLog(fs:String);
begin
  log:=fs;
end;

procedure SAX.addLog(fs:String);
begin
  log:=log+fs+#13#10;
end;

end.

